## dtkdeclarative 5.7.24.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" DTK_FILE_VERSION)
string(STRIP "${DTK_FILE_VERSION}" DTK_FILE_VERSION)
set(DTK_VERSION "${DTK_FILE_VERSION}" CACHE STRING "Define project version")
project(DtkDeclarative
    VERSION "${DTK_VERSION}"
    DESCRIPTION "DTK Declarative module"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dtkdeclarative"
    LANGUAGES CXX
)

if (${PROJECT_VERSION_MAJOR} STREQUAL "5")
    set(QT_DEFAULT_MAJOR_VERSION "5")
    set(QT_VERSION_MAJOR "5")
    set(EnableQt5 on)
    set(EnableDtk5 on)
    set(EnableQt6 off)
    set(EnableDtk6 off)
elseif(${PROJECT_VERSION_MAJOR} STREQUAL "6")
    set(QT_DEFAULT_MAJOR_VERSION "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
    set(EnableQt5 off)
    set(EnableDtk5 off)
    set(EnableQt6 on)
    set(EnableDtk6 on)
else()
    message(FATAL_ERROR "Only support DTK_VERSION is 5 or 6")
endif()

set(ENABLE_COV OFF CACHE BOOL "Generate coverage info")
set(LIB_NAME dtk${DTK_VERSION_MAJOR}declarative)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

include(DtkBuildConfig)
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "Library install path")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DDeclarative" CACHE STRING "Headers install path")
set(TEMPLATE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/qtcreator/templates/wizards/projects/qml${DTK_VERSION_MAJOR}-app-template" CACHE STRING "Directory to install QtCreator template")
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Dtk${DTK_VERSION_MAJOR}Declarative" CACHE STRING "CMake config file install directory")
set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig" CACHE STRING "Directory to install pkg-config file")
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "Qt pri module install directory")
set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")

set(USE_QQuickStylePluginPrivate OFF)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core QuickControls2)

if (${QT_VERSION_MAJOR} STREQUAL "6")
    if (${Qt6QuickControls2_VERSION} VERSION_GREATER_EQUAL "6.10.0")
        set(QT_NO_PRIVATE_MODULE_WARNING ON)
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS CorePrivate QuickControls2Private)
    endif()
endif()

if(EnableQt5)
if(TARGET Qt::QuickControls2 AND TARGET Qt::QuickControls2Private)
    set(USE_QQuickStylePluginPrivate ON)
endif()
endif()
if(EnableQt6)
if(TARGET Qt6::QuickControls2 AND TARGET Qt6::QuickControls2Private)
    set(USE_QQuickStylePluginPrivate ON)
endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wextra")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # 加上 ASAN 检查后可能会导致 DEBUG 应用启动后退出。可以加上 ASAN_OPTIONS 环境变量来防止应用退出
    # ASAN_OPTIONS="halt_on_error=0" ASAN_OPTIONS="new_delete_type_mismatch=0"
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -fno-omit-frame-pointer")
    set(BUILD_TESTING ON)
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

set(DDECLARATIVE_TRANSLATIONS_DIR "dtk${PROJECT_VERSION_MAJOR}/DDeclarative/translations" CACHE STRING "DDeclarative translations directory")
set(DDECLARATIVE_TRANSLATIONS_PATH "share/${DDECLARATIVE_TRANSLATIONS_DIR}")
set(TRANSLATIONS_INSTALL_PATH "${DDECLARATIVE_TRANSLATIONS_PATH}")

set(URI "org.deepin.dtk")
string(REPLACE "." "/" URI_PATH ${URI})
set(PLUGIN_NAME dtkdeclarativeplugin)
set(STYLE_PLUGIN_NAME qtquickcontrolschameleonstyleplugin)
set(PLUGIN_OUTPUT_DIR ${PROJECT_BINARY_DIR}/plugins)

if(EnableQt5)
    add_subdirectory(src)
    add_subdirectory(qmlplugin)
endif()
if(EnableQt6)
    add_subdirectory(qt6)
endif()
add_subdirectory(chameleon)
add_subdirectory(examples)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
    add_dependencies(unit-test ${PLUGIN_NAME} ${STYLE_PLUGIN_NAME})
    if(EnableQt6)
        add_dependencies(unit-test dtkdeclarativeprivatesplugin dtkdeclarativesettingsplugin)
    endif()
endif()

# Install wizards template
set(QML_TEMPLATE_QTVERSION_INDEX 0)
if(EnableQt5)
    set(QML_TEMPLATE_QTVERSION_INDEX 3)
endif()
configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/qml-app-template/wizard.json.in"
    "${CMAKE_CURRENT_BINARY_DIR}/wizard.json"
    INSTALL_DESTINATION "${TEMPLATE_INSTALL_DIR}"
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wizard.json" DESTINATION "${TEMPLATE_INSTALL_DIR}")
install(DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/misc/qml-app-template/" DESTINATION "${TEMPLATE_INSTALL_DIR}" FILES_MATCHING PATTERN "*" PATTERN "*.in" EXCLUDE)

configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/DtkDeclarativeConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfig.cmake"
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfigVersion.cmake"
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
# Install cmake config file
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfig.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfigVersion.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
# Install pkg-config file
configure_file("${PROJECT_SOURCE_DIR}/misc/dtkdeclarative.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/dtk${DTK_VERSION_MAJOR}declarative.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/dtk${DTK_VERSION_MAJOR}declarative.pc" DESTINATION "${PKGCONFIG_INSTALL_DIR}")
# Install qmake module config file
configure_file("${CMAKE_CURRENT_LIST_DIR}/misc/qt_lib_dtkdeclarative.pri.in" "${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdeclarative.pri" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdeclarative.pri" DESTINATION "${MKSPECS_INSTALL_DIR}")

=== chameleon/CMakeLists.txt ===
set(PLUGIN_NAME ${STYLE_PLUGIN_NAME})

find_package(Dtk${DTK_VERSION_MAJOR}Gui REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS
    Qml
    Quick
    QuickControls2 REQUIRED
)
if(EnableQt5)
    find_package(Qt${QT_VERSION_MAJOR}QuickCompiler)
endif()

if("${QT_VERSION_MAJOR}" STREQUAL "6")
  if(${Qt6Qml_VERSION} VERSION_GREATER_EQUAL "6.10.0")
    set(QT_NO_PRIVATE_MODULE_WARNING ON)
    find_package(
      Qt6
      COMPONENTS QmlPrivate QuickPrivate QuickControls2Private
      REQUIRED)
  endif()
endif()

set(QML_FILES
    ApplicationWindow.qml
    BusyIndicator.qml
    Button.qml
    CheckBox.qml
    CheckDelegate.qml
    ComboBox.qml
    Control.qml
    DelayButton.qml
    DialogButtonBox.qml
    Dial.qml
    Frame.qml
    GroupBox.qml
    ItemDelegate.qml
    ListView.qml
    MenuItem.qml
    Menu.qml
    MenuSeparator.qml
    PageIndicator.qml
    Pane.qml
    Popup.qml
    ProgressBar.qml
    RadioButton.qml
    RoundButton.qml
    ScrollBar.qml
    ScrollView.qml
    ScrollIndicator.qml
    Slider.qml
    SpinBox.qml
    StackView.qml
    Switch.qml
    TextArea.qml
    TextField.qml
    ToolTip.qml
)
set(SRC_FILES
    qtquickcontrols2chameleonstyleplugin.h qtquickcontrols2chameleonstyleplugin.cpp
)

if(EnableQt5)
    file(GLOB _qml_files ${QML_FILES})
    set(TARGETPATH "QtQuick/Controls.2/Chameleon")
    set(PLUGIN_INSTALL_DIR "${QML_INSTALL_DIR}/${TARGETPATH}")

    qtquick_compiler_add_resources(RESOURCES ${CMAKE_CURRENT_LIST_DIR}/qml.qrc)

    add_library(${PLUGIN_NAME} SHARED
        ${SRC_FILES}
        ${RESOURCES} #   qml.qrc
    )
    set_target_properties(${PLUGIN_NAME} PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${PLUGIN_OUTPUT_DIR}/Chameleon"
    )

    find_program(COMPILER
        NAMES qmlcachegen
        REQUIRED
    )

    set(QMLC_FILES)
    foreach(QML_FILE ${_qml_files})
        get_filename_component(EXTENSION ${QML_FILE} EXT)
        if(EXTENSION STREQUAL ".qml" OR EXTENSION STREQUAL ".js" OR EXTENSION STREQUAL ".ui.qml")
            set(OUTPUT_FILE "${QML_FILE}c")
            execute_process(COMMAND ${COMPILER} ${QML_FILE} -o ${OUTPUT_FILE})
            list(APPEND QMLC_FILES ${OUTPUT_FILE})
        endif()
    endforeach()

    set(QML_DIR "${CMAKE_CURRENT_BINARY_DIR}/qmldir")
    configure_file("${CMAKE_CURRENT_LIST_DIR}/qmldir.in" "${QML_DIR}" @ONLY)
    # copy qmldir
    add_custom_command(TARGET ${PLUGIN_NAME}
       POST_BUILD
       COMMAND ${CMAKE_COMMAND} -E
       copy_if_different
       "${QML_DIR}"    #in-file
       "${PLUGIN_OUTPUT_DIR}/Chameleon/qmldir"                            #out-file
    )

    install(TARGETS ${PLUGIN_NAME} DESTINATION ${PLUGIN_INSTALL_DIR})
    install(FILES
        ${QML_DIR}
        ${_qml_files}
        ${QMLC_FILES}
        DESTINATION ${PLUGIN_INSTALL_DIR}
    )
endif()

if(EnableQt6)
    qt_add_qml_module(${PLUGIN_NAME}
        URI "Chameleon"
        VERSION "1.0"
        CLASS_NAME QtQuickControls2ChameleonStylePlugin
        PLUGIN_TARGET ${PLUGIN_NAME}
        OUTPUT_DIRECTORY
            "${PLUGIN_OUTPUT_DIR}/Chameleon"
        NO_PLUGIN_OPTIONAL
        NO_GENERATE_PLUGIN_SOURCE
        SOURCES ${SRC_FILES}
        QML_FILES ${QML_FILES}
    )
    install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/Chameleon/" DESTINATION "${QML_INSTALL_DIR}/Chameleon")
endif()

dtk_extend_target(${PLUGIN_NAME} EnableCov ${ENABLE_COV})

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::QuickControls2
)

if(USE_QQuickStylePluginPrivate)
    target_compile_definitions(${PLUGIN_NAME} PRIVATE
        USE_QQuickStylePlugin)
    target_link_libraries(${PLUGIN_NAME} PRIVATE
        Qt${QT_VERSION_MAJOR}::QuickControls2Private
    )
endif()

=== qmlplugin/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/qmlplugin/targets.cmake)
add_library(${PLUGIN_NAME} SHARED)

dtk_extend_target(${PLUGIN_NAME} EnableCov ${ENABLE_COV})

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${PLUGIN_NAME}_interface
    ${LIB_NAME}
)

set_target_properties(${PLUGIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}"
)

# copy qmldir
add_custom_command(TARGET ${PLUGIN_NAME}
   POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E
   copy_if_different
   "${PROJECT_SOURCE_DIR}/qmlplugin/qmldir"    #in-file
   "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/qmldir"    #out-file
)

install(TARGETS ${PLUGIN_NAME} DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")
install(FILES "${PROJECT_SOURCE_DIR}/qmlplugin/qmldir" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")

=== src/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/src/targets.cmake)

find_package(Qt${QT_VERSION_MAJOR}QuickCompiler)

# Quick compiler gen qmlc
file(GLOB QML_RCS ${PROJECT_SOURCE_DIR}/src/dtkdeclarative_qml.qrc)
qtquick_compiler_add_resources(RESOURCES
    ${QML_RCS}
)
# Add translation source file
qt5_add_translation(QM_FILES ${TS_FILES})

add_library(${LIB_NAME} SHARED
    ${RESOURCES}
    ${QM_FILES}
    ${PROJECT_SOURCE_DIR}/src/dtkdeclarative_shaders.qrc
)

dtk_extend_target(${LIB_NAME} EnableCov ${ENABLE_COV})
target_compile_definitions(${LIB_NAME} PRIVATE
    D_IGNORE_DEPRECATIONS
)

set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Declarative
)

target_link_libraries(${LIB_NAME}
PUBLIC
    ${LIB_NAME}_properties
PRIVATE
    ${LIB_NAME}_sources
)

# Install translations
install(FILES ${QM_FILES} DESTINATION "${TRANSLATIONS_INSTALL_PATH}")

# Install library
install(TARGETS ${LIB_NAME} EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets DESTINATION "${LIB_INSTALL_DIR}")
# Install export targets
install(EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets NAMESPACE Dtk:: FILE Dtk${DTK_VERSION_MAJOR}DeclarativeTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")

=== examples/exhibition/CMakeLists.txt ===
set(BIN_NAME dtk-exhibition)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Quick QuickControls2)
find_package(Dtk${DTK_VERSION_MAJOR}Core REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR}Gui REQUIRED)

set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie -Wl,--as-needed")

if (EnableQt5)
    set(QML_RCS ${CMAKE_CURRENT_LIST_DIR}/qml.qrc)
endif()
if (EnableQt6)
    set(QML_RCS ${CMAKE_CURRENT_LIST_DIR}/qml-qt6.qrc)
endif()
add_executable(${BIN_NAME}
    ${CMAKE_CURRENT_LIST_DIR}/main.cpp
    ${CMAKE_CURRENT_LIST_DIR}/assets.qrc
    ${QML_RCS}
)

target_compile_options(${BIN_NAME} PRIVATE "-fpic")

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::QuickControls2
    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Gui
)

set(EXAMPLE_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}")
if (EnableQt6)
    set(EXAMPLE_INSTALL_DIR "${LIB_INSTALL_DIR}/dtk${PROJECT_VERSION_MAJOR}/DDeclarative")
endif()

install(TARGETS ${BIN_NAME} DESTINATION ${EXAMPLE_INSTALL_DIR})

=== qt6/src/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/src/targets.cmake)

find_package(Qt${QT_DEFAULT_MAJOR_VERSION}ShaderTools)

include(${PROJECT_SOURCE_DIR}/qt6/src/qml.cmake)
qt_add_qml_module(${LIB_NAME}
    PLUGIN_TARGET ${PLUGIN_NAME}
    URI ${URI}
    VERSION "1.0"
    SHARED
    NO_GENERATE_PLUGIN_SOURCE
    NO_PLUGIN_OPTIONAL
    QML_FILES
        ${QML_DTK_CONTROLS}
    SOURCES
        ${SRCS} ${HEADERS}
        dquickextendregister_p.h
    OUTPUT_DIRECTORY
        "${PLUGIN_OUTPUT_DIR}/${URI_PATH}"
)

dtk_extend_target(${LIB_NAME} EnableCov ${ENABLE_COV})
dtk_extend_target(${PLUGIN_NAME} EnableCov ${ENABLE_COV})
target_compile_definitions(${LIB_NAME} PRIVATE
    D_IGNORE_DEPRECATIONS
)

qt_add_translations(${LIB_NAME}
    TS_FILES ${TS_FILES}
    QM_FILES_OUTPUT_VARIABLE QM_FILES
    IMMEDIATE_CALL
)

set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Declarative
)

target_link_libraries(${LIB_NAME}
PUBLIC
    ${LIB_NAME}_properties
PRIVATE
    ${LIB_NAME}_sources
)

file(GLOB QML_RCS dtkdeclarative_qml.qrc dtkdeclarative_overridable_qml.qrc)
qt_add_resources(RESOURCES
    ${QML_RCS}
    ${ASSETS_RCS}
)
target_sources(${LIB_NAME} PRIVATE ${RESOURCES})

qt_add_shaders(${LIB_NAME} "_dtkdeclarative_shaders_ng"
    BATCHABLE
    PRECOMPILE
    PREFIX
        "/dtk/declarative"
    FILES
        "shaders_ng/quickitemviewport.vert"
        "shaders_ng/quickitemviewport.frag"
        "shaders_ng/quickitemviewport-opaque.vert"
        "shaders_ng/quickitemviewport-opaque.frag"
        "shaders_ng/cornerscolorshader.vert"
        "shaders_ng/cornerscolorshader.frag"
        "shaders_ng/shadowmaterial.vert"
        "shaders_ng/shadowmaterial.frag"
)

include(${PROJECT_SOURCE_DIR}/qmlplugin/targets.cmake)
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${PLUGIN_NAME}_interface
    ${LIB_NAME}
)

# 禁用此插件的 RPATH/RUNPATH，因为依赖库在标准系统路径中
set_target_properties(${PLUGIN_NAME} PROPERTIES
    INSTALL_RPATH ""
    BUILD_WITH_INSTALL_RPATH TRUE
)

# Install library
install(TARGETS ${LIB_NAME} EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets DESTINATION "${LIB_INSTALL_DIR}")
# Install export targets
install(EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets NAMESPACE Dtk${DTK_VERSION_MAJOR}:: FILE Dtk${DTK_VERSION_MAJOR}DeclarativeTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")
# Install translations
install(FILES ${QM_FILES} DESTINATION "${TRANSLATIONS_INSTALL_PATH}")
# Install plugin
install(TARGETS ${PLUGIN_NAME} DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")
install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")

=== qt6/src/qml/settings/CMakeLists.txt ===
#####################################################################
## dtkdeclarativesettingsplugin Plugin:
#####################################################################

qt_add_qml_module(dtkdeclarativesettingsplugin
    PLUGIN_TARGET dtkdeclarativesettingsplugin
    URI "${URI}.settings"
    VERSION "1.0"
    SOURCES
        ${PROJECT_SOURCE_DIR}/src/private/dsettingscontainer_p.h
        ${PROJECT_SOURCE_DIR}/src/private/dsettingscontainer.cpp
    QML_FILES
        "SettingsDialog.qml"
        "OptionDelegate.qml"
        "CheckBox.qml"
        "LineEdit.qml"
        "ComboBox.qml"
        "NavigationTitle.qml"
        "ContentTitle.qml"
        "ContentBackground.qml"
    OUTPUT_DIRECTORY
        "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/settings"
)

dtk_extend_target(dtkdeclarativesettingsplugin EnableCov ${ENABLE_COV})

if("${QT_VERSION_MAJOR}" STREQUAL "6")
    if (${Qt6Core_VERSION} VERSION_GREATER_EQUAL "6.10.0")
        find_package(Qt6 REQUIRED COMPONENTS CorePrivate QuickPrivate QmlPrivate)
    endif()
endif()

target_link_libraries(dtkdeclarativesettingsplugin
PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::CorePrivate
    Qt${QT_VERSION_MAJOR}::QuickPrivate
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::QmlPrivate
    ${LIB_NAME}
)

# 禁用此插件的 RPATH/RUNPATH，因为依赖库在标准系统路径中
set_target_properties(dtkdeclarativesettingsplugin PROPERTIES
    INSTALL_RPATH ""
    BUILD_WITH_INSTALL_RPATH TRUE
)

install(TARGETS dtkdeclarativesettingsplugin DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/settings")
install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/settings/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/settings")

=== debian/changelog ===
dtkdeclarative (5.7.24.3) unstable; urgency=medium

  * Release 5.7.24

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 16 Oct 2025 19:45:07 +0800

dtkdeclarative (5.7.23) unstable; urgency=medium

  * Release 5.7.23

 --  yeshanshan <packages@deepin.org>  Thu, 25 Sep 2025 16:49:39 +0800

dtkdeclarative (5.7.22) unstable; urgency=medium

  * Release 5.7.22

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 04 Sep 2025 19:28:12 +0800

=== debian/control ===
Source: dtkdeclarative
Section: libs
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat ( =12),
 cmake,
 qtdeclarative5-dev,
 qtbase5-dev-tools,
 qtquickcontrols2-5-dev,
 libdtkgui-dev,
 libdtkcore-dev,
 qtdeclarative5-private-dev,
 qtbase5-private-dev,
 pkg-kde-tools,
 libgtest-dev,
 doxygen,
 qttools5-dev-tools,
 qttools5-dev,
 doxyqml,
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: qml-module-qtquick-controls2-styles-chameleon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml-module-qtquick-shapes (>= 5.11.3), qml-module-qtgraphicaleffects,
 libdtkdeclarative5( =${binary:Version})
Description: Deepin Tool Kit Qt Quick Controls 2 QML module
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.

Package: libdtkdeclarative5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  libdtkcore5 (>= 5.6.12)
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.
 .
 This package contains the shared libraries.

Package: libdtkdeclarative-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkdeclarative5( =${binary:Version})
Description: Deepin Tool Kit Gui Devel library
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.
 .
 This package contains the header files and shared libraries of DtkDeclarative

Package: libdtkdeclarative-doc
Architecture: any
Depends: ${misc:Depends}
Description: Deepin Tool Kit Gui Devel library (Document)
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.

Package: dtk-exhibition
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkdeclarative5( =${binary:Version}),
 qml-module-qtquick-controls2-styles-chameleon( =${binary:Version})
Description: Deepin Tool Kit QML Controls example.
 This package contains a applicatioin.

## dtkdeclarative 5.7.26

=== debian/changelog ===
dtkdeclarative (5.7.26) unstable; urgency=medium

  * Release 5.7.26

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 06 Nov 2025 17:05:00 +0800

dtkdeclarative (5.7.25) unstable; urgency=medium

  * Release 5.7.25

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 30 Oct 2025 21:46:36 +0800

dtkdeclarative (5.7.24) unstable; urgency=medium

  * Release 5.7.24

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 16 Oct 2025 19:45:07 +0800
